import 'dart:html';
import 'package:rad_textures/rad_textures.dart';
import 'package:vector_math/vector_math_browser.dart';

void main() {
  window.onLoad.listen((e) { _create(); });
}

void _plot_noise(String canvas_id, TSampler noise_callback)
{
  CanvasElement canvas = query("#$canvas_id");
  CanvasRenderingContext2D ctx = canvas.context2d;
  //ctx.fillStyle = 'black';
  //ctx.fillRect(0, 0, canvas.width, canvas.height);
  ImageData imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
  num scale = 0.013;
  for(num x = 0; x < canvas.width; x++) {
    for(num y = 0; y < canvas.height; y++) {
      num sample = noise_callback(new vec3(x * scale, y * scale, 0.0));
      imageData.data[(y * canvas.width + x) * 4 + 0] = 0;
      imageData.data[(y * canvas.width + x) * 4 + 1] = 
          FASTFLOOR((sample * 0.5 + 0.5) * 255);
      imageData.data[(y * canvas.width + x) * 4 + 2] = 0;
      imageData.data[(y * canvas.width + x) * 4 + 3] = 255;
    }
  }
  ctx.putImageData(imageData, 0, 0, 0, 0, canvas.width, canvas.height);  
}

num noise3_map(vec3 v) { return noise3(v.x, v.y, v.z); }
num RidgedMultifractal_Default_map(vec3 v) { return RidgedMultifractal_Default(v.x, v.y, v.z); }
num turbulence_default_map(vec3 v) { return turbulence_default(v.x, v.y, v.z); }
num FCellNoise3_map(vec3 v) { return FCellNoise3(v.x, v.y, v.z); }
num fBm_default_map(vec3 v) { return fBm_default(v.x, v.y, v.z); }

void _create() {
  _plot_noise("canvas_simplex_noise", noise3_map);
  _plot_noise("canvas_ridged_multifractal", RidgedMultifractal_Default_map);
  _plot_noise("canvas_turbulence", turbulence_default_map);
  _plot_noise("canvas_cell_noise", FCellNoise3_map);
  _plot_noise("canvas_fbm", fBm_default_map);
}
