import 'dart:html';
import 'package:rad_textures/rad_textures.dart';
import 'package:vector_math/vector_math_browser.dart';

void main() {
  window.onLoad.listen((e) => _create());
}

num /*shade*/ SphereRay(vec3 vCamera, vec3 vSphere, vec3 vScreen) {
  vec3 vCast = vScreen - vCamera;
  double scale = intersectRaySphere(vCamera, vCast, vSphere, 5.0);
  if(double.INFINITY != scale) {
    vec3 intersect = vCast.scale(scale) + vCamera;
    vec3 normal = intersect - vSphere;
    normal.normalize();
    return normal.z.abs();
  } else {
    return 0.0;
  }
}

void _create() {
  CanvasElement canvas = query("#canvas_ray_traced_sphere");
  CanvasRenderingContext2D ctx = canvas.context2d;
  ImageData imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
  vec3 vSphere = new vec3(0.0, 0.0, 5.0);
  vec3 vCamera = new vec3(0.0, 0.0, -6.0);
  num half_canvas_width = canvas.width / 2;
  num half_canvas_height = canvas.height / 2;
  for(num x = 0; x < canvas.width; x++) {
    for(num y = 0; y < canvas.height; y++) {
      vec3 vScreen = new vec3
          ((x - half_canvas_width) / 100.0, (y - half_canvas_height) / 100.0, 0.0);
      imageData.data[(y * canvas.width + x) * 4 + 0] = 0;
      imageData.data[(y * canvas.width + x) * 4 + 1] =
          (SphereRay(vCamera, vSphere, vScreen) * 200).toInt();
      imageData.data[(y * canvas.width + x) * 4 + 2] = 0;
      imageData.data[(y * canvas.width + x) * 4 + 3] = 255;
    }
  }
  ctx.putImageData(imageData, 0, 0, 0, 0, canvas.width, canvas.height);  
}
